<?php

namespace Drp\SimpleCms\Http\Controllers\Admin;

use Drp\SimpleCms\Contracts\ContentFactory;
use Illuminate\Routing\Controller;
use Illuminate\View\View;

class ContentListingController extends Controller
{
    /**
     * @var ContentFactory
     */
    private $contentFactory;

    public function __construct(ContentFactory $contentFactory)
    {
        $this->contentFactory = $contentFactory;
    }

    public function index(string $contentType): View
    {
        $contentModel = $this->contentFactory->makeContentClass($contentType);
        $content = $contentModel->latestContent();

        if (view()->exists("admin.content.$contentType.index")) {
            return view("admin.content.$contentType.index", compact('content', 'contentType'));
        }

        return view('simpleCms::index', compact('content', 'contentType'));
    }
}
