<?php

namespace Drp\SimpleCms;

use Drp\SimpleCms\Contracts\Publishable;
use Drp\SimpleCms\Scopes\PreviewScope;
use Drp\SimpleCms\Scopes\PublishedScope;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Relations\HasMany;

trait Previewer
{
    public function allVersionsOfContent(): HasMany
    {
        return $this->hasMany(static::class, 'content_id', 'content_id')
            ->withoutGlobalScopes([
                PreviewScope::class,
                PublishedScope::class,
            ]);
    }

    public function scopeHasNoDraftOrInReview(Builder $query): Builder
    {
        return $query->whereDoesntHave('allVersionsOfContent', function ($query): void {
            $query->where('status', Publishable::STATUS_DRAFT)
                ->orWhere('status', Publishable::STATUS_REVIEW);
        });
    }
}
